//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%41F81E800189.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%41F81E800189.cm

//## begin module%41F81E800189.cp preserve=no
//## end module%41F81E800189.cp

//## Module: Grid%41F81E800189; Package body
//## Subsystem: XSFit::Fit%3677C9158350
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSFit/Fit/Grid.cxx

//## begin module%41F81E800189.additionalIncludes preserve=no
//## end module%41F81E800189.additionalIncludes

//## begin module%41F81E800189.includes preserve=yes
#include <XSsymbol.h>
#include <XSstreams.h>
#include <XSUtil/Parse/XSparse.h>
#include <XSUtil/Utils/XSstream.h>
//## end module%41F81E800189.includes

// Grid
#include <XSFit/Fit/Grid.h>
//## begin module%41F81E800189.declarations preserve=no
//## end module%41F81E800189.declarations

//## begin module%41F81E800189.additionalDeclarations preserve=yes
//## end module%41F81E800189.additionalDeclarations


// Class Grid::ParameterSpec 

Grid::ParameterSpec::ParameterSpec (int paramIndex, int fullIndex, Real low, Real high, int levels, bool logSpacing)
  //## begin Grid::ParameterSpec::ParameterSpec%41F903FB0029.hasinit preserve=yes
      : log(logSpacing),      
        lowRange(low),
        highRange(high),
        parIndex(paramIndex),
        fullFitIndex(fullIndex),
        intervals(levels),
        name(""),
        units(""),
        value(0.),
        address(0),
        parameterValues()
  //## end Grid::ParameterSpec::ParameterSpec%41F903FB0029.hasinit
  //## begin Grid::ParameterSpec::ParameterSpec%41F903FB0029.initialization preserve=yes
  //## end Grid::ParameterSpec::ParameterSpec%41F903FB0029.initialization
{
  //## begin Grid::ParameterSpec::ParameterSpec%41F903FB0029.body preserve=yes
  //## end Grid::ParameterSpec::ParameterSpec%41F903FB0029.body
}


// Class Grid::InvalidParameter 

Grid::InvalidParameter::InvalidParameter (const std::string& diag)
  //## begin Grid::InvalidParameter::InvalidParameter%41F9047B0240.hasinit preserve=yes
  : YellowAlert(string("Invalid Parameter: "))  
  //## end Grid::InvalidParameter::InvalidParameter%41F9047B0240.hasinit
  //## begin Grid::InvalidParameter::InvalidParameter%41F9047B0240.initialization preserve=yes
  //## end Grid::InvalidParameter::InvalidParameter%41F9047B0240.initialization
{
  //## begin Grid::InvalidParameter::InvalidParameter%41F9047B0240.body preserve=yes
   tcerr << diag << '\n';
  //## end Grid::InvalidParameter::InvalidParameter%41F9047B0240.body
}


// Class Grid::InsufficientParameterArguments 

Grid::InsufficientParameterArguments::InsufficientParameterArguments (const string& diag)
  //## begin Grid::InsufficientParameterArguments::InsufficientParameterArguments%41F9047D00BC.hasinit preserve=no
  //## end Grid::InsufficientParameterArguments::InsufficientParameterArguments%41F9047D00BC.hasinit
  //## begin Grid::InsufficientParameterArguments::InsufficientParameterArguments%41F9047D00BC.initialization preserve=yes
  //## end Grid::InsufficientParameterArguments::InsufficientParameterArguments%41F9047D00BC.initialization
{
  //## begin Grid::InsufficientParameterArguments::InsufficientParameterArguments%41F9047D00BC.body preserve=yes
  //## end Grid::InsufficientParameterArguments::InsufficientParameterArguments%41F9047D00BC.body
}


// Class Grid 

//## begin Grid::FLAG%41F90348034E.attr preserve=no  public: static Real {UC} SMALL
const Real Grid::s_FLAG = SMALL;
//## end Grid::FLAG%41F90348034E.attr

//## begin Grid::INTERVALS%41F9035B01EB.attr preserve=no  private: static int {UC} 10
const int Grid::INTERVALS = 10;
//## end Grid::INTERVALS%41F9035B01EB.attr

Grid::Grid()
  //## begin Grid::Grid%41F8FBAA003C_const.hasinit preserve=yes
      : m_minStat(1.0),
        m_parameter(),
        m_grid(),
        m_contourLevels()
  //## end Grid::Grid%41F8FBAA003C_const.hasinit
  //## begin Grid::Grid%41F8FBAA003C_const.initialization preserve=yes
  //## end Grid::Grid%41F8FBAA003C_const.initialization
{
  //## begin Grid::Grid%41F8FBAA003C_const.body preserve=yes
  //## end Grid::Grid%41F8FBAA003C_const.body
}


Grid::~Grid()
{
  //## begin Grid::~Grid%41F8FBAA003C_dest.body preserve=yes
   SpecContainer dummy;
   replaceParameterSettings(dummy);
  //## end Grid::~Grid%41F8FBAA003C_dest.body
}



//## Other Operations (implementation)
void Grid::replaceParameterSettings (SpecContainer& newSetting) throw ()
{
  //## begin Grid::replaceParameterSettings%41F8FC840367.body preserve=yes
   std::swap(newSetting,m_parameter);       
   for (SpecContainer::iterator d = newSetting.begin(); d != newSetting.end(); ++d) delete *d;    
   newSetting.clear(); 
  //## end Grid::replaceParameterSettings%41F8FC840367.body
}

bool Grid::retrieveBestSetting (const StringArray& userString, IntegerArray& userIndex, StringArray& parString, IntegerArray& parIndex)
{
  //## begin Grid::retrieveBestSetting%41F8FC970301.body preserve=yes

           // deal with "best" or "current" arguments.
   StringArray::const_iterator is (userString.begin());
   StringArray::const_iterator isEnd (userString.end());
   IntegerArray::iterator ii(userIndex.begin());
   parIndex.reserve (userIndex.size());
   parString.reserve (userIndex.size());
   const string TEST("cCbB");
   size_t numberOfBCargs(0);
   bool isBest = false;
   while (is != isEnd)
   {
      // loc = -1 if not present, 0 or 1 if "current".
      const string& t (*is);
      int loc( TEST.find(t[0]));
      // need to test that string isn't a modelName:parameter 
      // index designation.
      bool qualifiedParIndex( is->find_first_of(':') != string::npos );
      if ( loc < 0 || qualifiedParIndex )
      {
         parString.push_back(*is);
         parIndex.push_back(*ii);
      }
      else 
      {
         isBest = ( loc > 1 );

         // removing an argument so have to reduce the index.
         IntegerArray::iterator iird(ii + 1);
         while (iird != userIndex.end())
         {
            (*iird) -= 1;
            ++iird;       
         }


         ++numberOfBCargs;
         if (numberOfBCargs == 2)
         {
            tcerr << " Warning: first setting of current/best "
                  << "applies to all parameters:\n should "
                  << "be entered only once\n";       
         }       
      }
      ++is, ++ii;    
   }
   return isBest;
  //## end Grid::retrieveBestSetting%41F8FC970301.body
}

Grid::ParameterSpec* Grid::makeParameterSpec (const Grid::ParameterSpec* const parameter, const string& parameterName, int paramIndex, int fullIndex, std::pair<Real,Real>& lim, bool logSetting, int intervals)
{
  //## begin Grid::makeParameterSpec%41F8FCA1029C.body preserve=yes
  ParameterSpec* r(0);
  if ( lim.first == lim.second )
  {
     string msg (" Range for parameter: ");
     msg += parameterName;
     msg += " has no width";
     throw InvalidParameter(msg);       
          
  }
  if ( logSetting )
  {
     if (  lim.first <= 0 || lim.second <= 0)
     {
        string msg (" Log setting requested but parameter limits include value 0 ");
        throw InvalidParameter(msg);       
     }
                       
  }                                       
        
  if ( parameter )
  {
     // we established that the previous
     // setting was valid.
     r = new ParameterSpec(*parameter);

     if ( lim.first !=  s_FLAG )
     {
          r->lowRange = lim.first;       
     }
     if ( lim.second != s_FLAG )
     {
          r->highRange = lim.second;       
     } 
     if ( intervals > 0)
     {
          r->intervals = intervals;       
     }
     r->log = logSetting;
     r->name = parameterName;
     r->parIndex = paramIndex;
     r->fullFitIndex = fullIndex;
  }
  else
  {
     // exit if parameter has insufficient settings.
     // this will leave the current set of parameters
     // to be stepped unchanged.
     if ( lim.first == s_FLAG || lim.second == s_FLAG )
     {
        string msg (" Error: insufficient arguments to grid parameter");
        msg += parameterName;
        throw InsufficientParameterArguments(msg);    
     }
     else 
     {
        int setLevel = intervals > 0 ? intervals : INTERVALS;
        r  = new ParameterSpec(paramIndex,fullIndex,lim.first,lim.second,setLevel,logSetting);
        r->name = parameterName;
     }
  }  
        
  return r;      
  //## end Grid::makeParameterSpec%41F8FCA1029C.body
}

bool Grid::parseParameterRange (const string& inputArg, int argIndex, int& base, std::pair<Real,Real>& lims, int& lev, bool& ls)
{
  //## begin Grid::parseParameterRange%41F8FCA9025F.body preserve=yes
  // Meant to process 1 delimited input argument at time, returning false
  // until the last argument of a ParameterSpec is detected.  
  // Assumes best|current specifier(s) has already been removed and processed.
  const string LOG("nNlL");
  string::size_type loc = LOG.find(inputArg[0]);
  bool result(false);
  if ( loc == string::npos )
  {
    // numeric arguments are in order
    // low, high, levels. The first two
    // are mandatory if not already set.
     int thisArg(argIndex - base);
     std::istringstream aa(inputArg);
     aa.exceptions(std::ios_base::failbit);
     string promptIfBad;
     try 
     {
        switch ( thisArg )
        {
	   case 0:
               // ParamID has already been processed, so do nothing.
	       break;
           case 1:
               promptIfBad = "Low Range";
               aa >> lims.first;
               break;
           case 2:
               promptIfBad = "High Range";
               aa >> lims.second;
               break;
           case 3:
               promptIfBad = "Intervals";
               aa >> lev;
               result = true;
               break;
           default:
               // Can get here if case 3 is skipped via comma delimiters.
               result = true;
               break;
        }
     }
     catch ( std::exception& )
     {
        tcout << "Input Error: setting for "
          << promptIfBad << " is invalid " << std::endl;

        Real replReal(0.);
        int replInt(0);
        string prompt(promptIfBad + ": ");
        switch (thisArg)
        {
           case 1:
              XSparse::getArg(tcin,replReal,lims.first,prompt);  
                lims.first = replReal;
              break;
           case 2: 
              XSparse::getArg(tcin,replReal,lims.second,prompt);  
              lims.second = replReal;
              break;
           case 3:
              XSparse::getArg(tcin,replInt,lev,prompt); 
              lev = replInt;
              result = true;
              break;
        }      
     }  
  } // end if numeric args
  else
  {
     // We have a log or nolog.  It should not get here if log|nolog
     // is the very last argument (with no trailing commas), in which
     // case the calling function should have trapped it. 
     ls = ( loc > 1);
     ++base;                                                               
  }   
  
  return result;
  //## end Grid::parseParameterRange%41F8FCA9025F.body
}

void Grid::resetContourMap ()
{
  //## begin Grid::resetContourMap%41F8FCB70059.body preserve=yes
   m_grid.resize(0);
  //## end Grid::resetContourMap%41F8FCB70059.body
}

Grid::ParameterSpec* Grid::paramSpecByIndex (int index) const
{
  //## begin Grid::paramSpecByIndex%41F8FCC702C0.body preserve=yes
  SpecContainer::const_iterator sp = m_parameter.begin();      
  SpecContainer::const_iterator spEnd = m_parameter.end();  
  ParameterSpec* target(0);
  // linear search through SpecContainer.
  while ( sp != spEnd )
  {
          if ( (*sp)->fullFitIndex == index ) target = (*sp);
          ++sp;       
  }    
  return target;     
  //## end Grid::paramSpecByIndex%41F8FCC702C0.body
}

void Grid::reinitialize (SpecContainer& newSetting)
{
  //## begin Grid::reinitialize%41F9589B007F.body preserve=yes
   replaceParameterSettings(newSetting);
  
   size_t Noutput (1);

   SpecContainer::iterator p    = m_parameter.begin();
   SpecContainer::iterator pEnd = m_parameter.end();

   while ( p != pEnd )
   {
      ParameterSpec*& spec = *p; 
      // make arrays of the fixed values of the parameters of the grid.
      spec->parameterValues.resize(spec->intervals+1,0.);       
      std::vector<Real>&  gv = spec->parameterValues;
      // size of the output array is product of the total number of parameter
      // values at which the fit will be evaluated.
      Noutput *= (spec->intervals + 1);
      gv[0] = spec->lowRange;
      gv[spec->intervals] = spec->highRange;

      if ( spec->log )
      {
         Real stepSize ( (log(spec->highRange) - log(spec->lowRange))/spec->intervals ); 
         for (size_t j = 1; j < spec->intervals; ++j)
         {
            gv[j] = exp(log(spec->lowRange) + j*stepSize);
         }        
      }
      else
      {
         Real stepSize ( (spec->highRange - spec->lowRange)/spec->intervals ) ;
         for (size_t j = 1; j < spec->intervals; ++j)
         {
            gv[j] = spec->lowRange + j*stepSize;
         }        

      }
      ++p;
   }
  
   // initialize the output array.
   m_grid.resize(Noutput,0);
    
  //## end Grid::reinitialize%41F9589B007F.body
}

// Additional Declarations
  //## begin Grid%41F8FBAA003C.declarations preserve=yes
  //## end Grid%41F8FBAA003C.declarations

//## begin module%41F81E800189.epilog preserve=yes
//## end module%41F81E800189.epilog
